import 'dart:io';

import 'package:circumstellar/circumstellar.dart';

import 'dart:convert';

import 'package:w_transport/vm.dart' show vmTransportPlatform;

void main() {
  var client = new DiscordClient(
      new DiscordAuthSet(
          Platform.environment['CIRCUMSTELLAR_TEST_TOKEN'], TokenType.Bot),
      vmTransportPlatform);
  client.dispatcher.messageCreate.listen((Message msg) async {
    if (msg.content == '!channel') {
      await msg.channel.createMessage('', embed: {
        'title': 'Channel info for: ${msg.channel.name}',
        'description': 'Discord channel description',
        'fields': [
          {
            'name': 'NSFW',
            'value': msg.channel.isNsfw.toString(),
            'inline': true
          },
          {'name': 'Topic', 'value': msg.channel.topic, 'inline': true},
          {'name': 'Guild ID', 'value': msg.channel.guildId, 'inline': true}
        ]
      });
    }
    if (msg.content.startsWith('!greet')) {
      await msg.channel.createMessage('Hello ${msg.mentions[0].username}!');
    }
  });
  client.dispatcher.ready.listen((empty) {
    print('Ready');
  });
  client.dispatcher.channelCreate.listen((chan) async {
    if (chan.type == ChannelType.GuildText) {
      var chan0 = (chan as GuildTextChannel);
      print('Channel ${chan0.name} has been created!');
    }
  });
  client.dispatcher.channelUpdate.listen((chan) async {
    if (chan.type == ChannelType.GuildText) {
      var chan1 = (chan as GuildTextChannel);
      print('Channel ${chan1.name} has been updated!');
    }
  });
  client.start();
}
